-- Love3D Library Test 7 --
require "Love3D"

function love.load()

	screenWidth			= 400
	screenHeight		= 300
	love.graphics.setMode( screenWidth, screenHeight)
	vp					= {}				-- view point
	vp.x				= screenWidth/2
	vp.y				= screenHeight/2	-- usual Love inverted Y axes
	fl					= 500				-- focal length
	love3D.load(fl, vp.x, vp.y)
	love3D.light.load()
	--points, polygons = love3D.preset.triCube3D(200, 0, 0, 0)
	-- syntax: love3D.preset.triCube3D(sideLength, ox, oy, oz)
	points, polygons	= love3D.preset.triPyramid(200,0,0,0)
	brt					= .85				-- brightness
	lgt					= {}
	lgt.x				= 0
	lgt.y				= 0
	lgt.z				= 0--200
	zSortUsingMinZ		= true
	zSortTech 			= "Using Minimum Z"
	isUsingBackfaceCull = true
	end

function love.keyreleased(key)
	--beetle.key(key)
	if key == "q" then
		zSortUsingMinZ = false
		zSortTech = "Using Average Z"
		elseif key == "e" then
			zSortUsingMinZ = true
			zSortTech = "Using Minimum Z"
		end
	if key == "w" and isUsingBackfaceCull then
		isUsingBackfaceCull = false
		elseif key == "w" and isUsingBackfaceCull == false then
			isUsingBackfaceCull = true
		end
	end

function love.update(dt)
	local angX = (love.mouse.getX() - vp.x) * (0.005 * dt)
	local angY = (love.mouse.getY() - vp.y) * (0.005 * dt)
	lgt.x = love.mouse.getX() - vp.x
	lgt.y = love.mouse.getY() - vp.y
	for i, v in ipairs(points) do
		v.y, v.z = love3D.func.rotateX(v.y, v.z, angX, 0, 0)
		v.x, v.z = love3D.func.rotateY(v.x, v.z, angY, 0, 0)
		end
	if zSortUsingMinZ then
		love3D.func.zSortTriangle2(polygons, points)
		else
			love3D.func.zSortTriangle(polygons, points)
		end

	love.graphics.setCaption("Sub's Love3D Test 7- Ref Modified")

	end

function love.draw()
	for i, v in ipairs(polygons) do
		if polygons[i].color[1] then
			r,g,b = polygons[i].color[1],polygons[i].color[2],polygons[i].color[3]
			else
			r,g,b = 255,0,0
			end
		love3D.light.set(lgt.x, lgt.y, lgt.z, brt, r,g,b)
		love3D.light.setAmbience(0, 0, 50)
		local p1, p2, p3 = points[v[1]], points[v[2]], points[v[3]]
		love.graphics.setColor(love3D.light.getNewColor(p1, p2, p3))
		love3D.graphics.triangle("fill", isUsingBackfaceCull, p1.x, p1.y, p1.z, p2.x, p2.y, p2.z, p3.x, p3.y, p3.z)
		end
	love.graphics.setColor(255 * brt, 255 * brt, 255 * brt, 255)
	love3D.graphics.circle2D("fill", lgt.x, lgt.y, lgt.z, 5, 20)
	love.graphics.setColor(255, 255, 255, 255)

	end

function love.keypressed( key )
	if key	== 'escape'		then love.event.push( 'quit' ) end
	end
